C----------------------------------------------------------------------
      subroutine intens(ix,ints,mux,muy,muz,tori)
      implicit none
      integer ix
      include 'iam.fi'
      real*8  ints,muz, mux, muy
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer sizeup(DIMSIZ),sizelo(DIMSIZ)
      integer qvkup(DIMTOT,Q_K:Q_V+DIMTOP),qvklo(DIMTOT,Q_K:Q_V+DIMTOP)
      integer qup(DIMQLP),qlo(DIMQLP) 
      real*8  vrup(DIMTOT),vrlo(DIMTOT),viup(DIMTOT),vilo(DIMTOT)
C
      real*8 eup,elo
      integer jup,jlo,fup,flo,tup,tlo,sup,slo,bup,blo
      
      jup=qlin(ix,Q_J,Q_UP)
      tup=qlin(ix,Q_T,Q_UP)
      sup=qlin(ix,Q_S,Q_UP)
      fup=qlin(ix,Q_F,Q_UP)
      bup=qlin(ix,Q_B,Q_UP)

      jlo=qlin(ix,Q_J,Q_LO)
      tlo=qlin(ix,Q_T,Q_LO)
      slo=qlin(ix,Q_S,Q_LO)
      flo=qlin(ix,Q_F,Q_LO)
      blo=qlin(ix,Q_B,Q_LO)

      if (sup.ne.slo) then
        ints=-99.0
        return
      end if
      if (abs(jup-jlo).gt.1) then
        ints=-98.0
        return
      end if

      if (jlo.gt.jup) then
        call rdvec(jlo,tlo,slo,flo,blo,sizeup,qvkup,vrup,viup,eup,qup)
        call rdvec(jup,tup,sup,fup,bup,sizelo,qvklo,vrlo,vilo,elo,qlo)
        call calir(ints,tori,jlo,jup,slo,muz, mux, muy
     $     ,sizeup,qvkup,vrup,viup
     $     ,sizelo,qvklo,vrlo,vilo)
      end if                                   
      if (jup.gt.jlo) then                     
        call rdvec(jup,tup,sup,fup,bup,sizeup,qvkup,vrup,viup,eup,qup)
        call rdvec(jlo,tlo,slo,flo,blo,sizelo,qvklo,vrlo,vilo,elo,qlo)
        call calir(ints,tori,jup,jlo,slo,muz, mux, muy
     $     ,sizeup,qvkup,vrup,viup
     $     ,sizelo,qvklo,vrlo,vilo)
      end if                                   
      if (jup.eq.jlo) then                     
        call rdvec(jup,tup,sup,fup,bup,sizeup,qvkup,vrup,viup,eup,qup)
        call rdvec(jlo,tlo,slo,flo,blo,sizelo,qvklo,vrlo,vilo,elo,qlo)
        call caliq(ints,tori,jup,jlo,slo,muz, mux, muy
     $     ,sizeup,qvkup,vrup,viup
     $     ,sizelo,qvklo,vrlo,vilo)
      end if
      return
      end

C ----------------------------------------------------------------------
      subroutine caliq(ints,tori,jup,jlo,gam,muz, mux, muy
     $     ,sizeup,qvkup,vrup,viup
     $     ,sizelo,qvklo,vrlo,vilo)
      implicit none
      include 'iam.fi'
      integer jup,jlo,gam
      real*8 ints,muz, mux, muy
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer sizeup(DIMSIZ),sizelo(DIMSIZ)
      integer qvkup(DIMTOT,Q_K:Q_V+DIMTOP),qvklo(DIMTOT,Q_K:Q_V+DIMTOP)
      real*8  vrup(DIMTOT),vrlo(DIMTOT),viup(DIMTOT),vilo(DIMTOT)
C
      real*8  intr,inti,dq,dj,tt
      integer ik,ik1,ik2,qk,qk1,qk2,iv,iv1,iv2,i,i1,i2
      integer itop,ntop
     
      if (jlo.ne.jup) pause 'CALIQ: intens error: jlo <> jup'
      ntop=ctlint(C_NTOP)
      inti=0.0
      intr=0.0
      dj=dble(jlo)
C     muz
      do ik=1, sizelo(S_K)
        do iv=1, sizelo(S_VV)
          i=ik+(iv-1)*sizelo(S_K)
          qk=qvklo(i,Q_K)
          dq=dble(qk)
          intr=intr+2.0*muz*dq*(vrlo(i)*vrup(i)+vilo(i)*viup(i))
          inti=inti+2.0*muz*dq*(vrlo(i)*viup(i)-vilo(i)*vrup(i))
        end do
      end do
C     mux/y
      do ik2=1, sizelo(S_K)-1
        qk2=qvkup(ik2,Q_K)
        ik1=ik2+1
        qk1=qvklo(ik1,Q_K)
        dq=sqrt((dj-dble(qk2))*(dj+dble(qk2)+1.0))
        do iv1=1, sizelo(S_VV)
          i1=ik1+(iv1-1)*sizelo(S_K)
          do iv2=1, sizeup(S_VV)
            i2=ik2+(iv2-1)*sizeup(S_K)
            tt=1.0
            if (gam.ne.0) then
              do itop=1, ntop
                tt=tt*tori(qk1,qk2
     $               ,qvklo(i1,Q_V+itop)-size(S_MINV+itop)+1
     $               ,qvkup(i2,Q_V+itop)-size(S_MINV+itop)+1
     $               ,gamma(gam,itop),itop)
              end do
            else
              if (iv1.ne.iv2) tt=0.0
            end if
            intr=intr
     $           -tt*mux*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            inti=inti
     $           -tt*mux*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
            inti=inti
     $           -tt*muy*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            intr=intr
     $           +tt*muy*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
          end do
        end do
      end do
      do ik2=2, sizelo(S_K)
        qk2=qvkup(ik2,Q_K)
        ik1=ik2-1
        qk1=qvklo(ik1,Q_K)
        dq=sqrt((dj+dble(qk2))*(dj-dble(qk2)+1.0))
        do iv1=1, sizelo(S_VV)
          i1=ik1+(iv1-1)*sizelo(S_K)
          do iv2=1, sizeup(S_VV)
            i2=ik2+(iv2-1)*sizeup(S_K)
            tt=1.0
            if (gam.ne.0) then
              do itop=1, ntop
                tt=tt*tori(qk1,qk2
     $               ,qvklo(i1,Q_V+itop)-size(S_MINV+itop)+1
     $               ,qvkup(i2,Q_V+itop)-size(S_MINV+itop)+1
     $               ,gamma(gam,itop),itop)
              end do
            else
              if (iv1.ne.iv2) tt=0.0
            end if
            intr=intr
     $           -tt*mux*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            inti=inti
     $           -tt*mux*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
            inti=inti
     $           +tt*muy*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            intr=intr
     $           -tt*muy*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
          end do
        end do
      end do
      ints=(intr**2+inti**2)*(2.0*dj+1.0)/(2.0*dj*(2.0*dj+2.0))
      return
      end

C ----------------------------------------------------------------------
C     Delta J = 1 ----------------------------------------------------------------
      subroutine calir(ints,tori,jup,jlo,gam,muz, mux, muy
     $     ,sizeup,qvkup,vrup,viup
     $     ,sizelo,qvklo,vrlo,vilo)
      implicit none
      include 'iam.fi'
      integer jup,jlo,gam
      real*8  ints,muz, mux, muy
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer sizeup(DIMSIZ),sizelo(DIMSIZ)
      integer qvkup(DIMTOT,Q_K:Q_V+DIMTOP),qvklo(DIMTOT,Q_K:Q_V+DIMTOP)
      real*8  vrup(DIMTOT),vrlo(DIMTOT),viup(DIMTOT),vilo(DIMTOT)
C
      real*8  intr,inti,dq,dj,tt
      integer ik,ik1,ik2,qk,qk1,qk2,iv,iv1,iv2,i,i1,i2
      integer itop,ntop
     
      if ((jlo+1).ne.jup) pause 'CALIR: intens error: jlo+1 <> jup'
      ntop=ctlint(C_NTOP)
      inti=0.0
      intr=0.0
      dj=dble(jlo)
C     mu_z
      do ik2=2, sizelo(S_K)+1
        qk2=qvkup(ik2,Q_K)
        ik1=ik2-1 
        qk1=qvklo(ik1,Q_K)
        do iv=1, sizelo(S_VV)
          i1=ik1+(iv-1)*sizelo(S_K)
          i2=ik2+(iv-1)*sizeup(S_K)
c          qk1=qvklo(i1,Q_K)
c          qk2=qvkup(i2,Q_K)
          if (qk1.ne.qk2) stop 'Error in CALIR : K numbers'
          dq=2.0*sqrt((dj+dble(qk1)+1.0)*(dj-dble(qk1)+1.0))
          intr=intr-muz*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
          inti=inti-muz*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
        end do
      end do
C     mux/y
      do ik2=1, sizelo(S_K)
        qk2=qvkup(ik2,Q_K)
        ik1=ik2  
        qk1=qvklo(ik1,Q_K)
        
        dq=sqrt((dj-dble(qk2))*(dj-dble(qk2)+1.0))
        do iv1=1, sizelo(S_VV)
          i1=ik1+(iv1-1)*sizelo(S_K)
          do iv2=1, sizeup(S_VV)
            i2=ik2+(iv2-1)*sizeup(S_K)
            tt=1.0
            if (gam.ne.0) then
              do itop=1, ntop
                tt=tt*tori(qk1,qk2
     $               ,qvklo(i1,Q_V+itop)-size(S_MINV+itop)+1
     $               ,qvkup(i2,Q_V+itop)-size(S_MINV+itop)+1
     $               ,gamma(gam,itop),itop)
              end do
            else
              if (iv1.ne.iv2) tt=0.0
            end if
            intr=intr
     $           +tt*mux*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            inti=inti
     $           +tt*mux*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
            inti=inti
     $           +tt*muy*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            intr=intr
     $           -tt*muy*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
          end do
        end do
      end do
      do ik2=3, sizelo(S_K)+2
        qk2=qvkup(ik2,Q_K)
        ik1=ik2-2
        qk1=qvklo(ik1,Q_K)
        dq=sqrt((dj+dble(qk2))*(dj+dble(qk2)+1.0))
        do iv1=1, sizelo(S_VV)
          i1=ik1+(iv1-1)*sizelo(S_K)
          do iv2=1, sizeup(S_VV)
            i2=ik2+(iv2-1)*sizeup(S_K)
            tt=1.0
            if (gam.ne.0) then
              do itop=1, ntop
                tt=tt*tori(qk1,qk2
     $               ,qvklo(i1,Q_V+itop)-size(S_MINV+itop)+1
     $               ,qvkup(i2,Q_V+itop)-size(S_MINV+itop)+1
     $               ,gamma(gam,itop),itop)
              end do
            else
              if (iv1.ne.iv2) tt=0.0
            end if
            intr=intr
     $           -tt*mux*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            inti=inti
     $           -tt*mux*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
            inti=inti
     $           +tt*muy*dq*(vrlo(i1)*vrup(i2)+vilo(i1)*viup(i2))
            intr=intr
     $           -tt*muy*dq*(vrlo(i1)*viup(i2)-vilo(i1)*vrup(i2))
          end do
        end do
      end do
      ints=(intr**2+inti**2)/(2.0*(2.0*dj+2.0))        
      return
      end

C ----------------------------------------------------------------------
      subroutine binnam(ij,gam,if,ib,binfname)
      implicit none
      include 'iam.fi'
      integer ij,if,gam,ib
      character*(*) binfname     

      if (if.ge.0) then
        write(binfname,'(A,2I1,A,2I1,A,I1,A,2I1)')
     $       'j',int(ij/10),mod(ij,10),
     $       'f',int(if/10),mod(if,10),
     $       'b',ib,
     $       '.s',int(gam/10),mod(gam,10)
      else
        write(binfname,'(A,2I1,A,I1,A,2I1)')
     $       'j',int(ij/10),mod(ij,10),
     $       'b',ib,
     $       '.s',int(gam/10),mod(gam,10)
      end if
      return
      end

C ----------------------------------------------------------------------
      subroutine wrvec(zr,zi,d,ij,gam,if,ib,qvk,qmk)
      implicit none
      include 'iam.fi'
      integer ij,if,gam,ib
      real*8 zr(DIMTOT,DIMTOT),zi(DIMTOT,DIMTOT)
      real*8 d(DIMTOT)
      integer qvk(DIMTOT,Q_K:Q_V+DIMTOP),qmk(DIMTOT,DIMQLP)
      integer ie,id,itop,bu,ios
      character*30 binfname     
      integer myand
      external myand

      call binnam(ij,gam,if,ib,binfname)
      call getfu(bu)
      if (myand(ctlint(C_PRI),AP_ST).ne.0)
     $     write(*,*)' Writing ',binfname
      
      open(bu,file=binfname,status='unknown',err=99,iostat=ios
     $     ,form='unformatted')
      write(bu,err=99,iostat=ios) (size(ie),ie=1,DIMSIZ)
      write(bu,err=99,iostat=ios) (qvk(ie,Q_K),
     $     (qvk(ie,Q_V+itop),itop=1,DIMTOP)
     $     ,ie=1,size(S_H))
      do id=1, size(S_H)
c        write(bu,'(F18.9,$)',err=99,iostat=ios) d(id)
c        write(bu,err=99,iostat=ios) d(id)
        write(bu,err=99,iostat=ios)  d(id), (qmk(id,ie),ie=1,DIMQLP),
     $       (zr(ie,id),zi(ie,id),ie=1,size(S_H))
      end do
      close (bu)
      return
 99   continue
      write(*,*) 'wrvec Error iostat', ios,ij,gam,if,ib,binfname
      return
      end

C----------------------------------------------------------------------
      subroutine getfu(myunit)
      implicit none
      integer myunit,funit
      data funit/10/
      save funit

      if (funit.gt.50) funit=10
      funit=funit+1
      myunit=funit
c      write(0,*)'funit ',myunit
      return
      end

C----------------------------------------------------------------------
      subroutine rdvec(ij,it,is,if,ib,mysize,qvk,vr,vi,e,qmk)
      implicit none
      include 'iam.fi'
      integer qvk(DIMTOT,Q_K:Q_V+DIMTOP)
      integer mysize(DIMSIZ)
      integer ij,it,is,if,ib,i,ie,itop,bu
      integer qmk(DIMQLP) 
      real*8  vr(DIMTOT),vi(DIMTOT),e
      character*30 binfname     

      call getfu(bu)
c      write(0,*)'rdvec',bu
      call binnam(ij,is,if,ib,binfname)
      open(bu,file=binfname,status='unknown',form='unformatted')
      read(bu) (mysize(ie),ie=1,DIMSIZ)
      read(bu) (qvk(ie,Q_K),
     $     (qvk(ie,Q_V+itop),itop=1,DIMTOP)
     $     ,ie=1,mysize(S_H))
      do i=1, mysize(S_H)
        read(bu) e, (qmk(ie),ie=1,DIMQLP),
     $       (vr(ie),vi(ie),ie=1,mysize(S_H))
        if (qmk(Q_T).eq.it) goto 10
      end do
      pause 'eigenvector not found'
 10   continue
      close (bu)
      return
      end

C ----------------------------------------------------------------------
      subroutine rdmat(ij,is,if,ib,mysize,qvk,vr,vi,e,qmk)
      implicit none
      include 'iam.fi'
      integer qvk(DIMTOT,Q_K:Q_V+DIMTOP)
      integer mysize(DIMSIZ)
      integer ij,is,if,ib,i,ie,itop,bu
      integer qmk(DIMTOT,DIMQLP) 
      real*8  vr(DIMTOT,DIMTOT),vi(DIMTOT,DIMTOT),e(DIMTOT)
      character*30 binfname     

      call getfu(bu)
c      write(0,*)'rdmat',bu
      call binnam(ij,is,if,ib,binfname)
      open(bu,file=binfname,status='unknown',form='unformatted')
      read(bu) (mysize(ie),ie=1,DIMSIZ)
      read(bu) (qvk(ie,Q_K),
     $     (qvk(ie,Q_V+itop),itop=1,DIMTOP)
     $     ,ie=1,mysize(S_H))
      do i=1, mysize(S_H)
        read(bu) e(i), (qmk(i,ie),ie=1,DIMQLP),
     $       (vr(ie,i),vi(ie,i),ie=1,mysize(S_H))
      end do
      close (bu)
      return
      end

C----------------------------------------------------------------------
      subroutine wrtori(tori,ib)
      implicit none
      include 'iam.fi'
      integer ib
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer ie,itop,ntop,isig,sigma,ivr,ivc,ikr,ikc,bu
      character*30 binfname     
      integer myand
      external myand

      call getfu(bu)
      ntop=ctlint(C_NTOP)
      write(binfname,'(A,1I1)')
     $     'tori.b',ib
      if (myand(ctlint(C_PRI),AP_ST).ne.0)
     $     write(*,*)' Writing ',binfname
      open(bu,file=binfname,status='unknown',form='unformatted')
      write(bu) (size(ie),ie=1,DIMSIZ)
      write(bu)
     $     ((gamma(isig,itop),itop=1,ntop),isig=1,size(S_G))

      do itop=1, ntop
        do isig=1, size(S_G)
          sigma=gamma(isig,itop)
          do ivr=1, size(S_V+itop)
            do ikr=-size(S_MAXK), size(S_MAXK)
              do ivc=1, size(S_V+itop)
                do ikc=-size(S_MAXK), size(S_MAXK)
                  write(bu) tori(ikr,ikc,ivr,ivc,sigma,itop)
     $                 ,ikr,ikc,ivr,ivc
                end do
              end do
            end do
          end do
        end do
      end do
      close (bu)
      
      return
      end

C----------------------------------------------------------------------
      subroutine rdtori(tori,ib)
      implicit none
      include 'iam.fi'
      integer ib
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer ie,itop,ntop,isig,sigma,ivr,ivc,ikr,ikc,bu
      character*30 binfname     
      integer myand
      external myand

      call getfu(bu)
      ntop=ctlint(C_NTOP)
      write(binfname,'(A,I1)')
     $     'tori.b',ib
      if (myand(ctlint(C_PRI),AP_ST).ne.0)
     $     write(*,*)' Reading Tori ',binfname
      open(bu,file=binfname,status='unknown',form='unformatted')
      read(bu) (size(ie),ie=1,DIMSIZ)
      read(bu)
     $     ((gamma(isig,itop),itop=1,ntop),isig=1,size(S_G))
      do itop=1, ntop
        do isig=1, size(S_G)
          sigma=gamma(isig,itop)
          do ivr=1, size(S_V+itop)
            do ikr=-size(S_MAXK), size(S_MAXK)
              do ivc=1, size(S_V+itop)
                do ikc=-size(S_MAXK), size(S_MAXK)
                  read(bu) tori(ikr,ikc,ivr,ivc,sigma,itop)
                end do
              end do
            end do
          end do
        end do
      end do
      close (bu)
      
      return
      end

C     -------------------------------------------------------------
      subroutine intal2(mux,muy,muz,temp)
      implicit none
      include 'iam.fi'
      real*8  muz, mux, muy
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer sizeup(DIMSIZ),sizelo(DIMSIZ)
      integer qvkup(DIMTOT,Q_K:Q_V+DIMTOP),qvklo(DIMTOT,Q_K:Q_V+DIMTOP)
C     real*8  vrup(DIMTOT),vrlo(DIMTOT),viup(DIMTOT),vilo(DIMTOT)
      integer qup(DIMTOT,DIMQLP),qlo(DIMTOT,DIMQLP)
      real*8  elo(DIMTOT),eup(DIMTOT),ints,freq
      real*8  hrup(DIMTOT,DIMTOT),hrlo(DIMTOT,DIMTOT)
      real*8  hiup(DIMTOT,DIMTOT),hilo(DIMTOT,DIMTOT)
      integer jup,jlo
      integer j1,j2,km1,km2,kp1,kp2,k1,k2,t1,t2,i,t01,t02
      integer fup,flo,tup,tlo,sup,slo,bup,blo,vup,vlo,isf,io
      integer iup(DIMVV),ilo(DIMVV)
      integer qsp(10,3*DIMTOT),ino,nno,iino,sp(0:DIMGAM)
      real*8  dsp(4,3*DIMTOT),sfrq
      real*8  kghz,bolt,temp,ener,statw,popl,hv
      parameter (kghz=20.8364)
C      character*6 fno
      
      fup=-1
      flo=-1
      isf=1
c      if (ctlint(C_NTOP).eq.0) isf=0
      do blo=1,size(S_NB)
        write(*,*)
        write(*,'(A,I2,28X,2A12,A9,4A9)') '-- B',blo,'Freq','Split'
     $       ,'Linestr.','total','stat.w.','popul.','hv-ener.'
        call rdtori(tori,blo)
        bup=blo
        do vlo=1,size(S_VV)
          vup=vlo
          do jlo=0, size(S_MAXK)
            do jup=jlo,min(jlo+1,size(S_MAXK))
              ino=0
              do slo=0, size(S_G)
                sup=slo
                sp(slo)=ino
            call rdmat(jup,sup,fup,bup,sizeup,qvkup,hrup,hiup,eup,qup)
            call rdmat(jlo,slo,flo,blo,sizelo,qvklo,hrlo,hilo,elo,qlo)
                do i=1, DIMVV
                  ilo(i)=0
                end do
                do tlo=1, sizelo(S_H)
                  ilo(qlo(tlo,Q_V1))=ilo(qlo(tlo,Q_V1))+1
                  do i=1, DIMVV
                    iup(i)=0
                  end do
                  do tup=1, sizeup(S_H)
                    iup(qup(tup,Q_V1))=iup(qup(tup,Q_V1))+1
                    freq=eup(tup)-elo(tlo)
                    if ((dabs(freq).lt.ctlpar(C_FRQLO))
     $                   .or.(dabs(freq).gt.ctlpar(C_FRQUP))) goto 10
                    if ((tup.le.tlo).and.(jup.eq.jlo)) goto 10
                    if ((qup(tup,Q_V1).ne.vup).or.
     $                   (qlo(tlo,Q_V1).ne.vlo)) goto 10

                    if (jup.gt.jlo) then                     
                      call calir(ints,tori,jup,jlo,sup,muz, mux, muy
     $                     ,sizeup,qvkup,hrup(1,tup),hiup(1,tup)
     $                     ,sizelo,qvklo,hrlo(1,tlo),hilo(1,tlo))
                    end if                                   
                    if (jup.eq.jlo) then                     
                      call caliq(ints,tori,jup,jlo,sup,muz, mux, muy
     $                     ,sizeup,qvkup,hrup(1,tup),hiup(1,tup)
     $                     ,sizelo,qvklo,hrlo(1,tlo),hilo(1,tlo))
                    end if
                    statw=2*jlo+1
                    if (ints.ge.ctlpar(C_INTLM)) then
                      ino=ino+1
                      if (ino.gt.3*DIMTOT) stop 'INTALL:error:ino'
                      qsp(1,ino)=sup
                      qsp(2,ino)=tlo
                      qsp(3,ino)=qlo(tlo,Q_K)
                      qsp(4,ino)=ilo(qlo(tlo,Q_V1))/2
                      qsp(5,ino)=(2*jlo+2-ilo(qlo(tlo,Q_V1)))/2
                      qsp(6,ino)=tup
                      qsp(7,ino)=qup(tup,Q_K)
                      qsp(8,ino)=iup(qup(tup,Q_V1))/2
                      qsp(9,ino)=(2*jup+2-iup(qup(tup,Q_V1)))/2
                      qsp(10,ino)=0
                      dsp(1,ino)=freq
                      dsp(2,ino)=ints
                      dsp(3,ino)=min(elo(tlo),eup(tup))
                    end if
 10                 continue
                  end do        ! tup
                end do          ! tlo
                ino=ino+1
                qsp(1,ino)=sup
                qsp(2,ino)=-1
                qsp(6,ino)=-1
              end do            ! Sup
              nno=ino
              do iino=1, nno
                tlo=qsp(2,iino)
                tup=qsp(6,iino)
C                write(*,*)'tlo,tup',tlo,tup
                do sup=0, size(S_G)
c                  do itry=1,2
                  do io=1, nno
                    ino=sp(sup)+io
C     check for end of sup
                    if ((qsp(2,ino).eq.-1)
     $                   .and.(qsp(6,ino).eq.-1)) goto 30
                    if ((tlo.eq.-1).and.(tup.eq.-1)
     $                   .and.(qsp(10,ino).eq.0)) goto 50
C     check for matching tup and tlo
                    if ((tlo.ne.qsp(2,ino))
     $                   .or.(tup.ne.qsp(6,ino))) goto 40
 50                 continue
                    freq=dsp(1,ino)
                    ints=dsp(2,ino)
                    ener=dsp(3,ino)
                    qsp(10,ino)=1
                    if (freq.gt.0.0) then
                      j1 =jup
                      t1 =qsp(6,ino)
                      k1 =qsp(7,ino)
                      km1=qsp(8,ino)
                      kp1=qsp(9,ino)
                      j2 =jlo
                      t2 =qsp(2,ino)
                      k2 =qsp(3,ino)
                      km2=qsp(4,ino)
                      kp2=qsp(5,ino)
                      if (sup.eq.isf) then
                        sfrq=freq
                        t01=t1
                        t02=t2
                      end if
                    else
                      j2 =jup
                      t2 =qsp(6,ino)
                      k2 =qsp(7,ino)
                      km2=qsp(8,ino)
                      kp2=qsp(9,ino)
                      j1 =jlo
                      t1 =qsp(2,ino)
                      k1 =qsp(3,ino)
                      km1=qsp(4,ino)
                      kp1=qsp(5,ino)
                      freq=-freq
                      if (sup.eq.isf) then
                        sfrq=freq
                        t01=t1
                        t02=t2
                      end if
                    end if
                    popl=exp(-ener/(kghz*temp))
                    hv  =1.0d0-exp(-freq/(kghz*temp))
                    bolt=statw*popl*hv*ints

                    if ((t02.eq.t2).and.(t01.eq.t1).and.(sup.gt.isf))
     $                   then
             write(*,'(20X,(A,I2),10X,F13.6,F10.4,5F9.4,2(A,2I3))')
     $               '  S',sup
     $               ,freq,(freq-sfrq)*1000.0,ints,bolt,statw,popl,hv
     $               ,'  K',k1,k2,'  t',t1,t2
                    else
                      if (sup.gt.0) then
             write(*,'(2(3I3,1X),3(A,I2),F13.6,10X,5F9.4,2(A,2I3))')
     $                 j1 ,km1, kp1,j2 ,km2, kp2,
     $               '  S',sup,'  V',vup,'  B',bup
     $               ,freq                   ,ints,bolt,statw,popl,hv
     $               ,'  K',k1,k2,'  t',t1,t2
                      end if
                    end if
                    if (sup.eq.0) then
             write(*,'(2(3I3,1X),A15    ,F13.6,10X,5F9.4,2(A,2I3))')
     $                 j1 ,km1, kp1,j2 ,km2, kp2,
     $               '  rigid  '
     $               ,freq                   ,ints,bolt,statw,popl,hv
     $               ,'  K',k1,k2,'  t',t1,t2
                    end if
 40                 continue
                  end do        ! io
c                  end do
 30               continue
                end do          ! sup
                if ((tlo.eq.-1).and.(tup.eq.-1)) goto 20
              end do            ! ino
 20           continue
            end do              ! Jup
          end do                ! Jlo
          write(*,*)
        end do                  ! Vlo
      end do                    ! Blo
      write(*,*) ' total is the product of Linestr., population-factor,'
      write(*,*) ' energy factor (hv), and the statistical weight'
      write(*,*)
      return
      end
C                fno=char(vup+64)//char(j1+64)//char(t1+64)
C     $               //char(j2+64)//char(t2+64)//char(sup+64)
C ----------------------------------------------------------------------
C     -------------------------------------------------------------
      subroutine intall(mux,muy,muz,temp)
      implicit none
      include 'iam.fi'
      real*8  muz, mux, muy
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer sizeup(DIMSIZ),sizelo(DIMSIZ)
      integer qvkup(DIMTOT,Q_K:Q_V+DIMTOP),qvklo(DIMTOT,Q_K:Q_V+DIMTOP)
C     real*8  vrup(DIMTOT),vrlo(DIMTOT),viup(DIMTOT),vilo(DIMTOT)
      integer qup(DIMTOT,DIMQLP),qlo(DIMTOT,DIMQLP)
      real*8  elo(DIMTOT),eup(DIMTOT),ints,freq
      real*8  hrup(DIMTOT,DIMTOT),hrlo(DIMTOT,DIMTOT)
      real*8  hiup(DIMTOT,DIMTOT),hilo(DIMTOT,DIMTOT)
      integer jup,jlo
      integer j1,j2,km1,km2,kp1,kp2,k1,k2,t1,t2,i
      integer fup,flo,tup,tlo,sup,slo,bup,blo,vup,vlo,isf
      integer iup(DIMVV),ilo(DIMVV)
      real*8  kghz,bolt,temp,popl,statw,hv
      parameter (kghz=20.8364)
      
      fup=-1
      flo=-1
      isf=0
      if (ctlint(C_NTOP).gt.0) isf=1
      
      do blo=1,size(S_NB)
        write(*,'(A,I2,25X,A12,A9,4A9)') '-- B',blo,'Freq','Linestr.'
     $       ,'total','stat.w.','popul.','hv-ener.'
        bup=blo
        call rdtori(tori,blo)
        do vlo=1,size(S_VV)
          vup=vlo
          do slo=isf,size(S_G)
            sup=slo
            do jlo=0, size(S_MAXK)
              do jup=jlo,min(jlo+1,size(S_MAXK))
            call rdmat(jup,sup,fup,bup,sizeup,qvkup,hrup,hiup,eup,qup)
            call rdmat(jlo,slo,flo,blo,sizelo,qvklo,hrlo,hilo,elo,qlo)
                do i=1, DIMVV
                  ilo(i)=0
                end do
                do tlo=1, sizelo(S_H)
                  ilo(qlo(tlo,Q_V1))=ilo(qlo(tlo,Q_V1))+1
                  do i=1, DIMVV
                    iup(i)=0
                  end do
                  do tup=1, sizeup(S_H)
                    iup(qup(tup,Q_V1))=iup(qup(tup,Q_V1))+1
                    freq=eup(tup)-elo(tlo)
                    if ((dabs(freq).lt.ctlpar(C_FRQLO))
     $                   .or.(dabs(freq).gt.ctlpar(C_FRQUP))) goto 10
                    if ((tup.le.tlo).and.(jup.eq.jlo)) goto 10
                    if ((qup(tup,Q_V1).ne.vup).or.
     $                   (qlo(tlo,Q_V1).ne.vlo)) goto 10
                    if (jup.gt.jlo) then                     
                      call calir(ints,tori,jup,jlo,sup,muz, mux, muy
     $                     ,sizeup,qvkup,hrup(1,tup),hiup(1,tup)
     $                     ,sizelo,qvklo,hrlo(1,tlo),hilo(1,tlo))
                    end if                                   
                    if (jup.eq.jlo) then                     
                      call caliq(ints,tori,jup,jlo,sup,muz, mux, muy
     $                     ,sizeup,qvkup,hrup(1,tup),hiup(1,tup)
     $                     ,sizelo,qvklo,hrlo(1,tlo),hilo(1,tlo))
                    end if
                    if (ints.ge.ctlpar(C_INTLM)) then
                      statw=2*jlo+1
                      if (freq.gt.0.0) then
                        j1 =jup
                        km1=iup(qup(tup,Q_V1))/2
                        kp1=(2*jup+2-iup(qup(tup,Q_V1)))/2
                        k1 =qup(tup,Q_K)
                        t1 =tup
                        j2 =jlo
                        km2=ilo(qlo(tlo,Q_V1))/2
                        kp2=(2*jlo+2-ilo(qlo(tlo,Q_V1)))/2
                        k2 =qlo(tlo,Q_K)
                        t2 =tlo
                        popl=exp(-elo(tlo)/(kghz*temp))
                        hv  =1.0d0-exp(-freq/(kghz*temp))
                        bolt=statw*popl*hv*ints
                      else
                        j2 =jup
                        km2=iup(qup(tup,Q_V1))/2
                        kp2=(2*jup+2-iup(qup(tup,Q_V1)))/2
                        k2 =qup(tup,Q_K)
                        t2 =tup
                        j1 =jlo
                        km1=ilo(qlo(tlo,Q_V1))/2
                        kp1=(2*jlo+2-ilo(qlo(tlo,Q_V1)))/2
                        k1 =qlo(tlo,Q_K)
                        t1 =tlo
                        freq=-freq
                        popl=exp(-eup(tup)/(kghz*temp))
                        hv  =1.0d0-exp(-freq/(kghz*temp))
                        bolt=statw*popl*hv*ints
                      end if
          if (gamma(sup,0).eq.0) then
          write(*,'(2(I3,A3,I3,1X),2(A,I2),F13.6,5F9.4,A,I2,2(A,2I3))')
     $                       j1 ,' K ', k1,j2 ,' K ',k2,
     $                       '  S',sup,'  V',vup
     $                    ,freq,ints,bolt,statw,popl,hv
     $                     ,'  B',bup,'  K',k1,k2,'  t',t1,t2
          else
          write(*,'(2(3I3,1X),2(A,I2),F13.6,5F9.4,A,I2,2(A,2I3))')
     $                       j1 ,km1, kp1,j2 ,km2, kp2,
     $                       '  S',sup,'  V',vup
     $                    ,freq,ints,bolt,statw,popl,hv
     $                     ,'  B',bup,'  K',k1,k2,'  t',t1,t2
          end if
                    end if
 10                 continue
                  end do
                end do
              end do
            end do
            write(*,*)
          end do
          write(*,*)
        end do
      end do
      write(*,*) ' total is the product of Linestr., population-factor,'
      write(*,*) ' energy factor (hv), and the statistical weight'
      return
      end

