C----------------------------------------------------------------------
      subroutine calvjk(j,gam,f,ib,h,evalv,ovv,rotm,rott,tori
     $     ,a,qmv,ifit,dfit,palc,pali,npar,fistat,evh)
C     calculation of the eigenvalues of one matrix with specified j,f,gam
C     the evalues are put in the field of dnv(1..ndata,Q_ENG,Q_UP/LO)
C     the deviations DE/DPi in dnv(1..ndata,DQ_ENG,Q_UP/LO(i))
C     fistat = 0 for regular calculation of Eigenvalues
C     fistat > 0  Eigenvalues for differential quotient

      implicit none
      include 'iam.fi'
      integer j, gam, f, ib, npar, fistat
      real*8  h(DIMTOT,DIMTOT),evh(DIMTOT)
      real*8  evalv(DIMV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  ovv(DIMV,DIMV,DIMOVV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  rotm(-DIMJ:DIMJ,-DIMJ:DIMJ,1:2,DIMTOP)
      real*8  rott(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,DIMTOP)
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      real*8  a(DIMPAR)
      real*8  palc(DIMFIT,-1:DIMPLC)
      integer pali(DIMFIT, 0:DIMPLC,2)
      integer qmv(DIMV),ifit(DIMPAR),dfit(DIMFIT)

C     quantum numbers
      integer qvk(DIMTOT,Q_K:Q_V+DIMTOP), qmk(DIMTOT,DIMQLP)
      integer qv(DIMTOT)
C     work
      real*8  e(DIMTOT),e2(DIMTOT),tau(2,DIMTOT)
      real*8  zr(DIMTOT,DIMTOT),zi(DIMTOT,DIMTOT)
      real*8  dedp(DIMPAR)
      integer id,ie,i,iv,ik,itop,ivr,ivc,ir,ic,it1,it2,ikr,ikc
      integer eused(DIMTOT), usert,ierr
      integer ruse(DIMVV,DIMVV,DIMTOP)
      character*30 fmtstr
      character*4 fnpre
      character*6 fnpost
      real*8 tt
      logical masave
      logical complex
      integer myand
      external myand

      integer  mclock,t1,t2
      external mclock

      masave=.false.
      if (ctlint(C_EVAL).gt.3)   masave=.true.

      if ((myand(ctlint(C_PRI),AP_ST).ne.0).and.(xde.ge.1))
     $     write(*,'(A,5I3)')
     $     'starting with J,S,B,F Fit_stat=',J,gam,ib,f,fistat
      fnpre='xiam'
      if (gam.eq.0) ctlint(C_NTOP)=0
      complex=.false.
      do i=1,ctlint(C_NTOP)
        if (a(PI_GAMA+(i-1)*DIMPIR+DIMPRR).ne.0.0) complex=.true.
      end do
      usert = 1
      if ((a(P_QYZ).ne.0.0).or.(a(P_QXY).ne.0.0)) complex=.true.

      size(S_K)=2*j+1
C     initialize the quantum no.s qvk
      i=0
      do iv=1, size(S_VV)
        do ik=1, size(S_K)
          i=i+1
          qvk(i,Q_K) =ik-j-1
          qv(i)=iv
          do itop=1, ctlint(C_NTOP)
            qvk(i,Q_V+itop)=qvv(iv,itop,ib)
          end do
        end do
      end do
      size(S_H)=i
      do ivr=1, size(S_H)
        do ivc=1, size(S_H)
          h(ivr,ivc)=0.0
        end do
      end do

      do itop=1, ctlint(C_NTOP)
        do ivr=1, size(S_VV)
          do ivc=1, size(S_VV)
            ruse(ivr,ivc,itop)=1
          end do
        end do
      end do

      do it1=1, ctlint(C_NTOP)
        do it2=1, ctlint(C_NTOP)
          if (it2.ne.it1) then
            do ivr=1, size(S_VV)
              do ivc=1, size(S_VV)
                if (qvv(ivr,it2,ib).ne.qvv(ivc,it2,ib)) then    
                  ruse(ivr,ivc,it1)=0
                end if
              end do
            end do
          end if
        end do
      end do

      if ((myand(ctlint(C_PRI),AP_ST).ne.0).and.(xde.ge.1)) then
        write(fmtstr,'(A,I1,A,I2,A)') '(',ctlint(C_NTOP),'I2,A,'
     $       ,size(S_VV),'I3)'
        write(*,*) fmtstr
        do itop=1, ctlint(C_NTOP)
          write(*,'(A,I3)') ' ruse array for top', itop 
          do ivr=1, size(S_VV)
            write(*,fmtstr)(qvv(ivr,it2,ib),it2=1,ctlint(C_NTOP))
     $           ,' | ',(ruse(ivr,ivc,itop),ivc=1, size(S_VV))
          end do
        end do
      end if 

      if (masave) then
        do itop=1,ctlint(C_NTOP)
          write(fnpost,'(I1,I1,A,I1,I1)')
     $         itop,gam,'.j',int(j/10),mod(j,10)
          open(55,file=fnpre//'t'//fnpost,status='unknown')
          write(55,*) size(S_V+itop)*size(S_K),0,0
          do ivr=1, size(S_V+itop)
            do ikr=1, size(S_K)
              write(55,*)
     $             ((rotm(qvk(ikr,Q_K),qvk(ikc,Q_K),1,itop)
     $             *tori(qvk(ikr,Q_K),qvk(ikc,Q_K),ivr,ivc
     $             ,gamma(gam,itop),itop)
     $             ,ikc=1,size(S_K))
     $             ,ivc=1, size(S_V+itop))
            end do
          end do
          close(55)
        end do
        do itop=1,ctlint(C_NTOP)
          write(fnpost,'(I1,I1,A,I1,I1)')
     $         itop,gam,'.j',int(j/10),mod(j,10)
          open(56,file=fnpre//'p'//fnpost,status='unknown')
          write(56,*) size(S_V+itop)*size(S_K),0,0
          do ivr=1, size(S_V+itop)
            do ikr=1, size(S_K)
              do ivc=1, size(S_V+itop)
                do ikc=1, size(S_K)
                  if (qvk(ikr,Q_K).eq.qvk(ikc,Q_K)) then
                    write(56,'(D22.14,$)')
     $                   ovv(ivr,ivc,PM_PI,gamma(gam,itop)
     $                   ,qvk(ikr,Q_K),itop)
                  else
                    write(56,'(D22.14,$)') 0.0
                  end if
                end do
              end do
              write(56,*)
            end do
          end do
          close(56)
        end do
        
        do it1=1,ctlint(C_NTOP)
          write(fnpost,'(I1,I1,A,I1,I1)')
     $         it1,gam,'.j',int(j/10),mod(j,10)
          open(55,file=fnpre//'r'//fnpost,status='unknown')
          write(55,*) size(S_H),0,0
          do ir=1, size(S_H)
            do ic=1, size(S_H)
              tt=1.0d0
              do it2=1,ctlint(C_NTOP)
                tt=tt*tori(qvk(ir,Q_K),    qvk(ic,Q_K),
     $                   qvk(ir,Q_V+it2),qvk(ic,Q_V+it2),
     $                   gamma(gam,it2),it2)
              end do
              write(55,'(D22.14,$)')
     $             rotm(qvk(ikr,Q_K),qvk(ikc,Q_K),1,it1)
     $             *tt
            end do
            write(55,*)
          end do
          close(55)
        end do
      end if

      if (gam.ne.0) then
C      t1=mclock()
C     build the rotated D^{T} E_{K v \sigma} D
C        if (usert.eq.0) then
C          call bld1vjk(j,gam,f,qvk,ruse,h,a,evalv,ovv,rotm,rott,tori)
C        else
        call bld2vjk(j,gam,f
     $         ,qvk,ruse,h,a,evalv,ovv,rotm,rott,tori,complex)
C        end if

c      write(*,*) 'bld2vjk',mclock()-t1

      else
        if (size(S_VV).gt.1) stop ' size vv > 1 for rigid rotor!'
      end if
C      t1=mclock()
      call addrig(j,gam,f
     $     ,qvk,ruse,h,a,evalv,ovv,rotm,rott,tori,complex)
        
c      write(*,*) 'addrig',mclock()-t1
      if (myand(ctlint(C_PRI),AP_MH).ne.0) then
        write(*,*) ' H_tot '
        do ir=1, size(S_H)
          do ic=1, size(S_H)
            if (abs(h(ir,ic)).lt.1000.0) then
              write(*,'(F10.5,$)') h(ir,ic)
            else
              write(*,'(F10.2,$)') h(ir,ic)
            end if
          end do
          write(*,*)
        end do
        write(*,*)
      end if
C---
C      t1=mclock()
      if (complex) then
        do ir=1, size(S_H)
          do ic=1, size(S_H)
            zr(ir,ic)=0.0
          end do
          zr(ir,ir)=1.0
        end do
        ierr=0
        call htrid3 (DIMTOT,size(s_h),h,evh,e,e2,tau)
        call tql2 (DIMTOT,size(s_h),evh,e,zr,ierr)
        if (ierr.ne.0) then
          write (*,'(a,i5)') 'Error in tql2 ',ierr
          stop
        endif
        call htrib3 (DIMTOT,size(S_H),h,tau,size(S_H),zr,zi)

C     sort eigenvalues in **ascending** order
        call heigsrt(evh,zr,zi,size(S_H),DIMTOT)

        do i=1, size(S_H)
          do ie=1, size(S_H)
            h(i,ie)=sign(dsqrt(zr(i,ie)**2+zi(i,ie)**2)
     $           ,zr(i,ie)+zi(i,ie))              
          end do
        end do
      else
        write(fnpost,'(A,I1,A,I1,I1)')
     $       's',gam,'.j',int(j/10),mod(j,10)
        if (masave) then
          open(55,file=fnpre//'h'//fnpost,status='unknown')
          write(55,*) size(S_H),j,gam
          do i=1, size(S_H)
            write(55,*)(h(i,ie),ie=1,size(S_H))
          end do
          close(55)
        end if
 
        call hdiag(DIMTOT,size(S_H),h,evh,e,ierr)
        if (ierr.ne.0) then
          write (*,'(a,i5)') 'Error in hdiag ',ierr
          stop
        endif
C     sort eigenvalues in **ascending** order
        call eigsrt(evh,h,size(S_H),DIMTOT)
C---
        if (masave) then
          open(55,file=fnpre//'e'//fnpost,status='unknown')
          write(55,*) size(S_H),j,gam
          do i=1, size(S_H)
            write(55,*) evh(i)
          end do
          close(55)
C---  
          open(55,file=fnpre//'v'//fnpost,status='unknown')
          write(55,*) size(S_H),j,gam
          do i=1, size(S_H)
            write(55,*)(h(i,ie),ie=1,size(S_H))
          end do
          close(55)
        end if
        do i=1, size(S_H)
          do ie=1, size(S_H)
            zi(i,ie)=0.0
            zr(i,ie)=h(i,ie)
          end do
        end do        
      end if
c      write(*,*) 'diag   ',mclock()-t1

      if (myand(ctlint(C_PRI),AP_EH).ne.0) then
        write(*,*) ' Eigenvectors'
        do ir=1, size(S_H)
          do ic=1, size(S_H)
            if (h(ir,ic).lt.1000.0) then
              write(*,'(2F10.6,A,$)') zr(ir,ic),zi(ir,ic),'; '
            else
              write(*,'(2F10.2,A,$)') zr(ir,ic),zi(ir,ic),'; '
            end if
          end do
          write(*,*)
        end do
        write(*,*)
        write(*,*) ' Eigenvalues'
        do ir=1, size(S_H)
          write(*,'(F20.8,A,$)') evh(ir),'; '
        end do
        write(*,*)
      end if
      
      call assgn(j,gam,f,ib,h,evh,qvk,qmv,qmk,qv,fistat)
        
C     save the eigenvalues  
      call esave(j,gam,f,ib,qmk,evh,eused)

C     write the eigenvalues and vectors to disk
      if ((ctlint(C_INTS).gt.0).and.(fistat.eq.0)) then
        call wrvec(zr,zi,evh,j,gam,f,ib,qvk,qmk)
      end if
            
C     calculate the deviation dedp
C      if (usert.eq.0) then
      complex=.true.
      if (complex) then
        do id=1, size(S_H)
          if ((eused(id).ne.0).or.(ctlint(C_DFRQ).ne.0)) then
            do ie=1, size(S_H)
              e(ie)=zr(ie,id)
              e2(ie)=zi(ie,id)
            end do
            call hcaldev(e,e2,j,gam,f,ib,ifit,npar
     $           ,qvk,ruse,a,dedp,evalv,ovv,rotm,tori)
            call devsave(j,gam,f,ib,qmk(id,Q_T)
     $           ,ifit,dfit,dedp,palc,pali)
          end if
        end do
c      else
c        do id=1, size(S_H)
c          if ((eused(id).ne.0).or.(ctlint(C_DFRQ).ne.0)) then
c            do ie=1, size(S_H)
c              e(ie)=zr(ie,id)
c            end do
c            call caldev(e,j,gam,f,ifit,npar
c     $           ,qvk,ruse,a,dedp,evalv,ovv,rotm,tori)
c            call devsave(j,gam,f,qmk(id,Q_T),ifit,dfit,dedp,palc)
c          end if
c        end do
      end if
      return
      end 

C----------------------------------------------------------------------
      subroutine addrig(j,gam,f,qvk,ruse
     $     ,h,a,evalv,ovv,rotm,rott,tori,complex)
      implicit none
      include 'iam.fi'
      integer j,gam,f
      integer qvk(DIMTOT,Q_K:Q_V+DIMTOP)
      integer ruse(DIMVV,DIMVV,DIMTOP)
      real*8  h(DIMTOT,DIMTOT),a(DIMPAR)
      real*8            evalv(DIMV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  ovv(DIMV,DIMV,DIMOVV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  rotm(-DIMJ:DIMJ,-DIMJ:DIMJ,1:2,DIMTOP)
      real*8  rott(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,DIMTOP)
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      logical complex
C     work
      real*8 vr(DIMTOT), vi(DIMTOT), vor(DIMTOT), voi(DIMTOT)
      integer i,iv

      do i =1, size(S_H)
        do iv=1, size(S_H)
          vr(iv)=0.0
          vor(iv)=0.0
          vi(iv)=0.0
          voi(iv)=0.0
        end do
        vr(i )=1.0d0
        call hmulthrr(j,gam,f
     $       ,qvk,ruse,a,vr,vi,vor,voi,evalv,ovv,rotm,tori,0,0)
        do iv=1, i
          h(i,iv)=h(i,iv)+vor(iv)
        end do
        do iv=i+1, size(S_H)
          h(i,iv)=h(i,iv)+voi(iv)
        end do
      end do
      return
      end

C----------------------------------------------------------------------
      subroutine hcaldev(vr,vi,j,gam,f,ib,ifit,npar
     $     ,qvk,ruse,a,dedp,evalv,ovv,rotm,tori)
C     (hermitian) calculation of the < J tau | Op | J tau' >  
      implicit none
      include 'iam.fi'
      real*8  vi(DIMTOT),vr(DIMTOT)
      integer j,gam,f,npar,ib
      integer qvk(DIMTOT,Q_K:Q_V1+DIMTOP-1), ifit(DIMPAR)
      integer ruse(DIMVV,DIMVV,DIMTOP)
      real*8  a(DIMPAR),dedp(DIMPAR)
      real*8            evalv(DIMV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  ovv(DIMV,DIMV,DIMOVV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  rotm(-DIMJ:DIMJ,-DIMJ:DIMJ,1:2,DIMTOP)
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
C     work
      real*8  da(DIMPAR)
      real*8  vor(DIMTOT),voi(DIMTOT)
      integer i,ifs

      do ifs=1, DIMPRR
        dedp(ifs)=0.0
      end do
      do ifs=1, DIMPRR
        if (ifit(ifs).ne.0) then
          do i=1,DIMPRR
            da(i)=0.0
          end do
          da(ifs)=1.0
          do i=1, size(S_H)
            vor(i)=0.0
            voi(i)=0.0
          end do
          call hmulthrr(j,gam,f
     $         ,qvk,ruse,da,vr,vi,vor,voi,evalv,ovv,rotm,tori,ifs,0)
          do i=1, size(S_H)
            dedp(ifs)=dedp(ifs)+vor(i)*vr(i)+voi(i)*vi(i)
          end do
        end if
      end do
      return
      end
      
C----------------------------------------------------------------------
      subroutine hmulthrr(j,gam,f
     $     ,qvk,ruse,a,vr,vi,vor,voi,evalv,ovv,rotm,tori,ifs,it)
C     multiply the complex vector vr,vi by the rigid part of the
C     Hamilton matrix, yielding vor,voi
      implicit none
      include 'iam.fi'
      integer j,gam,f,ifs,it
      integer qvk(DIMTOT,Q_K:Q_V1+DIMTOP-1)
      integer ruse(DIMVV,DIMVV,DIMTOP)
      real*8  a(DIMPAR)
      real*8  vr(DIMTOT),vor(DIMTOT),vi(DIMTOT),voi(DIMTOT)
      real*8            evalv(DIMV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  ovv(DIMV,DIMV,DIMOVV,-DIMSIG:DIMSIG,-DIMJ:DIMJ,DIMTOP)
      real*8  rotm(-DIMJ:DIMJ,-DIMJ:DIMJ,1:2,DIMTOP)
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)

C     work
      real*8  dk,dj,djj1,dff,t,t1,t2,djjc
      real*8  e1,df,dff1,di,dii1,dg
      real*8  adelk,adelj,ah2,ah3,ahk,ar6,ahjk,ahj
      integer ik,ir,ic,ivr,ivc,itop
      integer off,voff
      integer myand
      external myand
      if (size(S_H).gt.DIMTOT) stop 'Dimension Error in HMULTHRR'

      dj=dble(j)
      djj1=dj*(dj+1.0)
      e1=0.0
C     djjc is used for spin rotation coupling to prevent a division by zero
C     for J=0
      djjc=1.0
      if ((ctlint(C_SPIN).ne.0).and.(j.gt.0).and.(f.ge.0)) then
        di=dble(ctlint(C_SPIN))/2.0d0
        dii1=di*(di+1.0)
        df=dble(f)/2.0d0
        dff1=df*(df+1.0)
        djjc=djj1
        dg=dff1-dii1-djj1
        if (ctlint(C_SPIN).gt.1) then
          e1= (0.75*dg*(dg+1.0)-dii1*djj1)
     $         /(2.0*di*(2.0*di-1.0)*djj1*(2.0*dj-1.0)*(2.0*dj+3.0))
        else
          e1=0.0
        end if
      end if

C     the centrifugal distortion parameters
C     Watson A 
      if (ctlint(C_RED).eq.0) then
        adelj=a(P_DJD)
        adelk=a(P_DKD)
        ar6  =0.0d0
        ahj  =a(P_HJD)
        ahjk =a(P_HJKD)
        ah2  =0.0d0
        ahk  =a(P_HKD)
        ah3  =0.0d0
      end if
C     Watson S
      if (ctlint(C_RED).eq.1) then
        adelj=-a(P_DJD)
        adelk=0.0d0
        ar6  =a(P_DKD)
        ahj  =a(P_HJD)
        ahjk =0.0d0
        ah2  =a(P_HJKD)
        ahk  =0.0d0
        ah3  =a(P_HKD)
      end if
C     van Eijck / Typke
      if (ctlint(C_RED).eq.2) then
        adelj=a(P_DJD)
        adelk=0.0d0
        ar6  =a(P_DKD)
        ahj  =0.5d0*a(P_HJD)
        ahjk =0.0d0
        ah2  =0.25d0*a(P_HJKD)
        ahk  =0.0d0
        ah3  =0.125d0*a(P_HKD)
      end if

      if ( (a(P_BJ) .ne.0.0).or.(a(P_BK) .ne.0.0).or.
     $     (a(P_DJ) .ne.0.0).or.(a(P_DJK).ne.0.0).or.
     $     (a(P_DK) .ne.0.0).or.(a(P_HJ ).ne.0.0).or.
     $     (a(P_HJK).ne.0.0).or.(a(P_HKJ).ne.0.0).or.
     $     (a(P_HK) .ne.0.0).or.(a(P_QZ) .ne.0.0).or.
     $     (a(P_CP) .ne.0.0).or.(a(P_CZ) .ne.0.0))then
        do ik=1, size(S_K)
          dk=dble(qvk(ik,Q_K))
          t=     a(P_BJ) *djj1
     $         + a(P_BK) *dk*dk
     $         - a(P_DJ) *djj1**2
     $         - a(P_DJK)*djj1*dk**2
     $         - a(P_DK) *dk**4
     $         + a(P_HJ) *djj1**3
     $         + a(P_HJK)*(djj1**2)*(dk**2)
     $         + a(P_HKJ)*djj1*(dk**4)
     $         + a(P_HK) *dk**6
     $         + a(P_QZ) * e1 * (3.0*(dk**2)-djj1)
     $         + a(P_CP) * 0.5*dg*(1.0-dk*dk/djjc)
     $         + a(P_CZ) * 0.5*dg*dk*dk/djjc
          do ivc=1, size(S_VV)
            ic=ik+size(S_K)*(ivc-1)
            vor(ic)=vor(ic)+vr(ic)*t
            voi(ic)=voi(ic)+vi(ic)*t
          end do
        end do
      end if
      
      if (a(P_PZ) .ne.0.0) then
        do ik=1, size(S_K)
          dk=dble(qvk(ik,Q_K))
          t=     a(P_PZ) *dk
          do ivc=1, size(S_VV)
            ic=ik+size(S_K)*(ivc-1)
            vor(ic)=vor(ic)+vr(ic)*t
            voi(ic)=voi(ic)+vi(ic)*t
          end do
        end do
      end if
      
      if ((ctlint(C_RED).eq.2).and. 
     $     ((ar6.ne.0.0d0).or.(ah2.ne.0.0d0))) then
        do ik=1, size(S_K)
          dk=dble(qvk(ik,Q_K))
          dff=  (djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0))
     $         +(djj1-dk*(dk-1.0))*(djj1-(dk-1.0)*(dk-2.0))
     $         -2.0d0*(djj1-dk**2)**2
          t=  (ar6 + ah2*djj1)*dff
          do ivc=1, size(S_VV)
            ic=ik+size(S_K)*(ivc-1)
            vor(ic)=vor(ic)+vr(ic)*t
            voi(ic)=voi(ic)+vi(ic)*t
          end do
        end do
      end if
        
C     real off diagonal k/k+1 
      if ((a(P_QXZ).ne.0.0)) then
        off=1
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=(1.0+2.0*dk)*dsqrt(djj1-dk*(dk+1.0))
          t=    e1* a(P_QXZ) *dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,0)
        end do
      end if

C     real off diagonal k/k+1 
      if ((a(P_PX).ne.0.0)) then
        off=1
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=0.5d0*dsqrt(djj1-dk*(dk+1.0))
          t=  a(P_PX) *dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,0)
        end do
      end if

C     imaginaer off diagonal k/k+1 
      if ((a(P_QYZ).ne.0.0)) then
        off=1
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=(1.0+2.0*dk)*dsqrt(djj1-dk*(dk+1.0))
          t=    e1* a(P_QYZ) *dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,1)
        end do
      end if

C     imaginaer off diagonal k/k+1 
      if ((a(P_PY).ne.0.0)) then
        off=1
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=0.5d0*dsqrt(djj1-dk*(dk+1.0))
          t=   a(P_PY) *dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,1)
        end do
      end if

C     real off diagonal k/k+2 
      if ((a(P_BD).ne.0.0).or.(adelj.ne.0.0).or.
     $    (adelk.ne.0.0).or.(a(P_QD).ne.0.0).or.
     $    (ahj.ne.0.0).or.(a(P_CD).ne.0.0).or.
     $    (ahjk.ne.0.0).or.(ahk.ne.0.0)) then
        off=2
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=0.5d0*dsqrt((djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0)))
          t=     a(P_BD) *dff
     $         - adelj   *2.0d0*dff*djj1
     $         - adelk   *dff*((dk+2.0d0)**2+dk**2)
     $         + ahj*2.0d0*dff*djj1**2
     $         + ahjk*dff*((dk+2.0d0)**2+dk**2)*djj1
     $         + ahk*dff*((dk+2.0d0)**4+dk**4)
     $         + a(P_QD) *dff*e1
     $         + a(P_CD) *0.5*dg*dff/djjc
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,0)
        end do
      end if

      if ((ctlint(C_RED).eq.2).and.(ah3.ne.0.0d0)) then
        off=2
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=dsqrt((djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0)))
     $         *((djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0))
     $         +(djj1-dk*(dk-1.0))*(djj1-(dk-1.0)*(dk-2.0))
     $         +(djj1-(dk+2.0)*(dk+3.0))*(djj1-(dk+3.0)*(dk+4.0)))
          t=  ah3*dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,0)
        end do
      end if

C     imaginaer off diagonal k/k+2 
      if ((a(P_QXY).ne.0.0)) then
        off=2
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=0.5d0*dsqrt((djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0)))
          t=    
     $         + a(P_QXY)*dff*e1*2.0
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,1)
        end do
      end if
 
C     Watson S off diagonal k/k+4 (evtl. change dff)
      if ((ar6.ne.0.0d0).or.(ah2.ne.0.0d0)) then
        off=4
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=dsqrt((djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0))
     $         *(djj1-(dk+2.0)*(dk+3.0))*(djj1-(dk+3.0)*(dk+4.0))) 
          t=   
     $          ar6*dff + ah2*djj1*dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,0)
        end do
      end if

C     Watson S off diagonal k/k+6 
      if (ah3.ne.0.0d0) then
        off=6
        do ik=1, size(S_K)-off
          dk=dble(qvk(ik,Q_K))
          dff=dsqrt((djj1-dk*(dk+1.0))*(djj1-(dk+1.0)*(dk+2.0))
     $         *(djj1-(dk+2.0)*(dk+3.0))*(djj1-(dk+3.0)*(dk+4.0))
     $         *(djj1-(dk+4.0)*(dk+5.0))*(djj1-(dk+5.0)*(dk+6.0))) 
          t=   
     $          ah3*dff
          call vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,0)
        end do
      end if
      
      return
      end

C----------------------------------------------------------------------
      subroutine vadd(ik,off,gam,t,tori,qvk,vr,vi,vor,voi,ri)
      implicit none
      include 'iam.fi'
      integer ik,off,gam,ri
      real*8  t
      integer qvk(DIMTOT,Q_K:Q_V1+DIMTOP-1)
      real*8  vr(DIMTOT),vor(DIMTOT),vi(DIMTOT),voi(DIMTOT)
      real*8  tori(-DIMJ:DIMJ,-DIMJ:DIMJ,DIMV,DIMV,
     $     -DIMSIG:DIMSIG,DIMTOP)
      integer ivr,ivc,ir,ic,itop,voff
      real*8  t1,t2
      integer myand
      external myand
      
      if (myand(ctlint(C_WOODS),32).ne.0) then
        do ivr=1, size(S_VV)
          do ivc=1, size(S_VV)
            ir=(ivr-1)*size(S_K)+ik
            ic=(ivc-1)*size(S_K)+ik
            t1=1.0d0
            t2=1.0d0
            do itop=1, ctlint(C_NTOP)
              voff=size(S_MINV+itop)-1
              t1=t1*tori
     $             (qvk(ir,Q_K),qvk(ic+off,Q_K)
     $             ,qvk(ir,Q_V+itop)-voff
     $             ,qvk(ic+off,Q_V+itop)-voff
     $             ,gamma(gam,itop),itop)
              t2=t2*tori
     $             (qvk(ir+off,Q_K),qvk(ic,Q_K)
     $             ,qvk(ir+off,Q_V+itop)-voff
     $             ,qvk(ic,Q_V+itop)-voff
     $             ,gamma(gam,itop),itop)
            end do  
            if (ri.eq.0) then
              vor(ir)    =vor(ir    )+vr(ic+off)*t*t2
              vor(ir+off)=vor(ir+off)+vr(ic    )*t*t1
              voi(ir)    =voi(ir    )+vi(ic+off)*t*t2
              voi(ir+off)=voi(ir+off)+vi(ic    )*t*t1
            else
              vor(ir)    =vor(ir    )+vi(ic+off)*t*t1
              vor(ir+off)=vor(ir+off)-vi(ic    )*t*t2
              voi(ir)    =voi(ir    )-vr(ic+off)*t*t1
              voi(ir+off)=voi(ir+off)+vr(ic    )*t*t2
            end if
          end do
        end do
      end if
      if (myand(ctlint(C_WOODS),32).eq.0) then
        if (ri.eq.0) then
          do ivc=1, size(S_VV)
            ic=ik+size(S_K)*(ivc-1)
            vor(ic)    =vor(ic    )+vr(ic+off)*t
            vor(ic+off)=vor(ic+off)+vr(ic    )*t
            voi(ic)    =voi(ic    )+vi(ic+off)*t
            voi(ic+off)=voi(ic+off)+vi(ic    )*t
          end do
        else
          do ivc=1, size(S_VV)
            ic=ik+size(S_K)*(ivc-1)
            vor(ic)    =vor(ic    )+vi(ic+off)*t
            vor(ic+off)=vor(ic+off)-vi(ic    )*t
            voi(ic)    =voi(ic    )-vr(ic+off)*t
            voi(ic+off)=voi(ic+off)+vr(ic    )*t
          end do
        end if
      end if
      return
      end
C----------------------------------------------------------------------
      subroutine esave(j,gam,f,ib,qmk,eval,eused)
      implicit none
      include 'iam.fi'
      real*8  eval(DIMTOT)
      integer j,gam,f,ib,qmk(DIMTOT,DIMQLP), eused(DIMTOT)
      integer il,ie,iq,vok
      integer use_t,use_tj
      integer myand,myor
      external myand,myor

      do ie=1, size(S_H)
        eused(ie)=0
      end do
        
      do iq=1,2
        do il=1, ctlint(C_NDATA) 
          if ((j.eq.qlin(il,Q_J,iq))
     $           .and.  (f.eq.qlin(il,Q_F,iq))
     $           .and. (ib.eq.qlin(il,Q_B,iq))
     $           .and.(gam.eq.qlin(il,Q_S,iq))) then 
            use_tj=myand(qlin(il,Q_STAT,iq),2)
            use_t =myand(qlin(il,Q_STAT,iq),4)
            do ie=1, size(S_H)
              if (
     $             ((qmk(ie,Q_T).eq.qlin(il,Q_T,iq))
     $             .and.(use_t.ne.0))
     $             .or.
     $             ((qmk(ie,Q_TJ).eq.qlin(il,Q_TJ,iq))
     $             .and.(use_tj.ne.0))
     $             .or.
     $             ((qmk(ie,Q_K).eq.qlin(il,Q_K,iq))
     $             .and.(use_t.eq.0).and.(use_tj.eq.0))
     $             ) then
                vok=0
                if ((qmk(ie,Q_V1).eq.qlin(il,Q_V1,iq)).or.(use_t.ne.0))
     $               vok=ctlint(C_NTOP)
                if ((myand(qlin(il,Q_STAT,iq),1).eq.0)
     $               .and.(vok.eq.ctlint(C_NTOP))) then 
                  dnv(il,NV_ENG,iq)=eval(ie)
                  qlin(il,Q_STAT,iq)=myor(qlin(il,Q_STAT,iq),1)
                  qlin(il,Q_TJ,iq)=qmk(ie,Q_TJ)
                  qlin(il,Q_T ,iq)=qmk(ie,Q_T )
                  qlin(il,Q_K, iq)=qmk(ie,Q_K )
                  qlin(il,Q_K2,iq)=qmk(ie,Q_K2)
                  qlin(il,Q_GK,iq)=qmk(ie,Q_GK)
                  qlin(il,Q_V1,iq)=qmk(ie,Q_V1)
C                  do itop=1, ctlint(C_NTOP)
C                    qlin(il,Q_V+itop,iq)=qmk(ie,Q_V+itop)
C                  end do
                  if (dln(il,LN_ERR).ne.NOFIT)
     $                 eused(ie)=myor(eused(ie),1)
                end if
              end if
            end do
          end if
        end do
      end do
      return
      end
C----------------------------------------------------------------------
      subroutine devsave(j,gam,f,ib,t,ifit,dfit,dedp,palc,pali)
      implicit none
      include 'iam.fi'
      integer j,gam,f,t,ib,ifit(DIMPAR),dfit(DIMFIT)
      real*8  dedp(DIMPAR)
      real*8  palc(DIMFIT,-1:DIMPLC)
      integer pali(DIMFIT, 0:DIMPLC,2)

      integer il,ip,iq,ifp
      
      do ifp=1, DIMFIT
        if (dfit(ifp).gt.0) then
          do il=1, ctlint(C_NDATA) 
            do iq=1,2
              if (      (j  .eq.qlin(il,Q_J,iq))
     $             .and.(f  .eq.qlin(il,Q_F,iq))
     $             .and.(gam.eq.qlin(il,Q_S,iq))
     $             .and.(t  .eq.qlin(il,Q_T,iq))
     $             .and.(ib .eq.qlin(il,Q_B,iq))) then
c                do ip=1, DIMPAR
c                  dnv(il,ifp+1,iq)=dnv(il,ifp+1,iq)
c     $                 +palc(ifp,ip)*dedp(ip)
c                end do
                do ip=1, pali(ifp,0,1)
                  if (pali(ifp,ip,2).eq.ib)
     $                 dnv(il,ifp+NV_DEF,iq)=dnv(il,ifp+NV_DEF,iq)
     $                 +palc(ifp,ip)*dedp(pali(ifp,ip,1))
                end do
              end if
            end do
          end do
        end if
      end do
      return
      end

C----------------------------------------------------------------------
      subroutine assgn(j,gam,f,ib,h,eval,qvk,qmv,qmk,qv,fistat)
C     qv: Quantum No.s from buildvjk ( 1  1  1  1  1  2  2  2  2  2 ..)
C     qk: Quantum No.s from buildvjk (-2 -1  0  1  2 -2 -1  0  1  2 ..)
C     qmv: Qunatum No.s from buildm  ( 0  3 -3  6  ...) or ( 1 -2  4 -5 ...)

      implicit none
      include 'iam.fi'
      integer j,gam,f,ib,fistat
      real*8  h(DIMTOT,DIMTOT),eval(DIMTOT)
      integer qvk(DIMTOT,Q_K:Q_V+DIMTOP)
      integer qmv(DIMV),qmk(DIMTOT,DIMQLP),qv(DIMTOT)

C     work
      integer i,ik,icc,iv,goodn,itop,ofistat
      integer i1,i2,iv1,iv2,v1,v2,ik1,ik2
C      integer bestk(DIMTOT),bestv(DIMTOT,DIMTOP),bestvv(DIMTOT)
      integer bestk(DIMTOT),bestvv(DIMTOT)
      integer bestvk(1)
C      integer scndk(DIMTOT),scndv(DIMTOT,DIMTOP),scndvv(DIMTOT)
      integer scndk(DIMTOT),scndvv(DIMTOT)
      integer scndvk(1)
      integer qtp(DIMVV),qvp(DIMVV)
      real*8  besth(DIMTOT),scndh(DIMTOT)
      real*8  besth1(1),scndh1(1)
      real*8  ksum(DIM2J1,DIMTOT)
C      real*8  vsum(DIMV,DIMTOT,DIMTOP)
      real*8  vsum(DIMVV,DIMTOT)
      real*8  vvsum(DIMVV,DIMTOT)
      real*8  difk,difv(DIMTOP),degn
      character*1 sgnchr
      logical kdegen
      data  ofistat /0/
C      save /xx/ofistat
C     
C      integer found(DIMTOT),fp,bestgk,bestfp,k
C
      if (size(S_K).gt.DIM2J1) stop ' ERROR: DIM 2J1 exceeded'
      degn=2.0d-4
      kdegen=.false.
      do icc=1, size(S_H)
        qmk(icc,Q_K)=NaQN
        qmk(icc,Q_T)=NaQN
        qmk(icc,Q_K2)=NaQN
        qmk(icc,Q_GK)=-200
      end do
      do iv=1, size(S_VV)
        qtp(iv)=0
        qvp(iv)=0
      end do
  
C     init the ksum and vsum matrix
      do ik=1, size(S_K)
        do i=1, size(S_H)
          ksum(ik,i)=0.0
        end do
      end do
c      do itop=1, ctlint(C_NTOP)
c        do i=1, size(S_H)
c          do iv=1, size(S_V+itop)
c            vsum(iv,i,itop)=0.0
c          end do
c        end do 
c      end do
      do i=1, size(S_H)
        do iv=1, size(S_VV)
          vvsum(iv,i)=0.0
          vsum(iv,i)=0.0
        end do
      end do

      if (ctlint(C_NTOP).gt.0) then
        do i=1, size(S_H)
          do iv=1, size(S_VV)
            do ik=1, size(S_K)
              i1=(iv-1)*size(S_K)+ik
              vvsum(iv,i)=vvsum(iv,i)+h(i1,i)**2
            end do
          end do
        end do
      end if
c      write(*,'(A,2I3)') ' vvsum: j,gam',j,gam
c      do i=1, size(S_H)
c        write(*,'(F10.5,$)') (vvsum(iv,i),iv=1, size(S_VV))
c         write(*,*)
c      end do

      if (ctlint(C_NTOP).eq.2) then
        do iv1=1, size(S_VV)
          v1=qvv(iv1,1,ib)
          v2=qvv(iv1,2,ib)
          if (v1.gt.v2) then
c     vfnd=.false.
            do iv2=1, size(S_VV)
              if ((qvv(iv2,2,ib).eq.v1).and.(qvv(iv2,1,ib).eq.v2)) then
C     vfnd=.true.
                do ik=1, size(S_K)
                  i1=(iv1-1)*size(S_K)+ik
                  i2=(iv2-1)*size(S_K)+ik
                  do i=1, size(S_H)
                    vsum(iv1,i)=vsum(iv1,i)+0.5*(h(i1,i)+h(i2,i))**2
                    vsum(iv2,i)=vsum(iv2,i)+0.5*(h(i1,i)-h(i2,i))**2
                  end do
                end do
                do i=1, size(S_H)
                  if (abs(vsum(iv1,i)-vsum(iv2,i))
     $                 .gt.abs(vvsum(iv1,i)-vvsum(iv2,i))) then
                    vvsum(iv1,i)=vsum(iv1,i)                
                    vvsum(iv2,i)=vsum(iv2,i)                
                  end if
                end do
              end if
            end do
          end if
        end do
      end if
c      write(*,'(A,2I3)') ' vsum: j,gam,',j,gam
c      do i=1, size(S_H)
c        write(*,'(I2,(F10.5,$))') i,
c     $       (vsum(iv,i),iv=1, size(S_VV))
c        write(*,*)
c      end do
c      write(*,'(A,2I3)') ' vvsum: j,gam,',j,gam
c      do i=1, size(S_H)
c        write(*,'(I2,F15.5,(F10.5,$))') i,
c     $       eval(i),(vvsum(iv,i),iv=1, size(S_VV))
c        write(*,*)
c      end do

c        if ((v1.eq.v2).or.(not.vfnd)) then
c          do ik=1, size(S_K)
c            i1=(iv1-1)*size(S_K)+ik
c            vvsum(iv1,i)=vvsum(iv1,i)+(h(i1,i))**2
c          end do
c        end if  
c      end do
c      kof=j+1
c      do iv=1, size(S_H)
c        do i=1, size(S_H)
c          do itop=1, ctlint(C_NTOP)
c            vsum(qvk(iv,Q_V+itop),i,itop)
c     $           = vsum(qvk(iv,Q_V+itop),i,itop)+h(iv,i)**2
c          end do
c          ksum(qvk(iv,Q_K)+kof,i)=ksum(qvk(iv,Q_K)+kof,i)+h(iv,i)**2
c          vvsum(qv(iv),i)       =vvsum(qv(iv),i)+h(iv,i)**2
c        end do  
c      end do
c      kof=j+1

c     if (gam.eq.0) then
c     do i=1, size(S_H)
c       do ik1=1, size(S_K)/2
c         ik2=size(S_K)-ik1+1
c         do iv=1, size(S_VV)
c           i1=(iv-1)*size(S_K)+ik1
c           i2=(iv-1)*size(S_K)+ik2
c           ksum(ik1,i)=ksum(ik1,i)+0.5d0*(h(i1,i)+h(i2,i))**2
c           ksum(ik2,i)=ksum(ik2,i)+0.5d0*(h(i1,i)-h(i2,i))**2
c         end do
c       end do  
c       ik=size(S_K)/2+1
c       do iv=1, size(S_VV)
c         i1=(iv-1)*size(S_K)+ik
c         ksum(ik,i)=ksum(ik,i)+h(i1,i)**2
c       end do
c     end do
c     else
      do i=1, size(S_H)
        do ik=1, size(S_K)
          do iv=1, size(S_VV)
            i1=(iv-1)*size(S_K)+ik
            ksum(ik,i)=ksum(ik,i)+h(i1,i)**2
          end do
        end do  
      end do
c     end if
      call maxof(ksum,DIM2J1,DIMTOT,size(S_K),1,size(S_H),bestk,scndk
     $     ,besth,scndh)
      call maxof(vvsum,DIMVV,DIMTOT,size(S_VV)
     $       ,1,size(S_H),bestvv,scndvv,besth,scndh)
c      do itop=1, ctlint(C_NTOP)
c        call maxof(vsum(1,1,itop),DIMV,DIMTOT,size(S_V+itop)
c     $       ,1,size(S_H),bestv(1,itop),scndv(1,itop),besth,scndh)
c      end do

      qvp(bestvv(1))=1
      do icc=1, size(S_H)-1
        if ((bestvv(icc+1).ne.bestvv(icc)).and.
     $       (qvp(bestvv(icc+1)).eq.0)) then
          qvp(bestvv(icc+1))=qvp(bestvv(icc))+1
        end if
      end do
      if (((ctlint(C_EVAL).gt.0).and.(fistat.eq.0))
     $     .or.(ctlint(C_EVAL).gt.1)) then
        if (ofistat.ne.fistat) then
          write(20,'(A,I3)') ' *********** FISTAT =',fistat
          ofistat=fistat
        end if
        write(20,'(/,4A3,2X,4A3,A15,4A)')
     $         'J','S','B','F','T','t','K','V',' Energy/GHz '
     $        ,'   best K(s)      vec ','  V   vec'
     $        ,' 2nd.K vec',' 2nd.V vec'
      endif 
      do icc=1, size(S_H)
        difk=1.0
        if (size(S_K).gt.1) then
          difk=(dabs(ksum(bestk(icc),icc)-ksum(scndk(icc),icc)))
        end if

        do itop=1, ctlint(C_NTOP)        
          difv(itop)=1.0
        end do
c        do itop=1, ctlint(C_NTOP)
c          if (size(S_V+itop).gt.1) then
c            difv(itop)=(dabs(vsum(bestv(icc,itop),icc,itop)
c     $         - vsum(scndv(icc,itop),icc,itop)))
c          end if
c        end do
        qmk(icc,Q_J)=j
        qmk(icc,Q_S)=gam
        qmk(icc,Q_F)=f
        qmk(icc,Q_B)=ib
        if (difk.lt.degn) then
          kdegen=.true.
          call maxof(h,DIMTOT,DIMTOT,size(S_H),icc,1,bestvk,scndvk,
     $         besth1,scndh1)
          if (abs(qvk(bestvk(1),Q_K)).ne.abs(qvk(bestk(icc),Q_K)))
     $         write(*,*) 'ERROR in assgn: K trouble',j,gam,icc 
          qmk(icc,Q_K)=sign(qvk(bestvk(1),Q_K),
     $         int(besth1(1)*scndh1(1)*10000.0))
          qmk(icc,Q_K2)=qmk(icc,Q_K)
          qmk(icc,Q_GK)=1000
          qtp(bestvv(icc))=qtp(bestvv(icc))+1
          qmk(icc,Q_TJ)=qtp(bestvv(icc))
          qmk(icc,Q_V1)=qvp(bestvv(icc))
          qmk(icc,Q_T )=icc
          sgnchr=' '
          if (qmk(icc,Q_K).gt.0) sgnchr='+'
          if (qmk(icc,Q_K).lt.0) sgnchr='-'
          if (((ctlint(C_EVAL).gt.0).and.(fistat.eq.0))
     $         .or.(ctlint(C_EVAL).gt.1)) then 
            write(20,
     $         '(4i3,2X,2i3,i2,A,i3,F15.8,1X,2I3,2F7.3,I4,F6.3,10X,I4,
     $           F6.3)')
     $         j,gam,ib,f,qmk(icc,Q_T),qmk(icc,Q_TJ),abs(qmk(icc,Q_K))
     $         ,sgnchr,qmk(icc,Q_V1),eval(icc)
     $         ,qvk(bestvk(1),Q_K) ,qvk(scndvk(1),Q_K)
     $         ,besth1(1),scndh1(1) 
     $         ,bestvv(icc),sqrt(vvsum(bestvv(icc),icc))
     $         ,scndvv(icc),sqrt(vvsum(scndvv(icc),icc))
C     $         ,(bestv(icc,itop),itop=1,ctlint(C_NTOP))
          end if
        else
          goodn=int(dabs(1.0-ksum(scndk(icc),icc)/ksum(bestk(icc),icc))
     $         *100.0)
          if (qmk(icc,Q_GK).ne.-200) write(0,'(A,5I3)')
     $         ' Assignment Warning',j,gam,ib,f,icc
          qmk(icc,Q_GK)=goodn
          qmk(icc,Q_K) =qvk(bestk(icc),Q_K) ! this is not correct, but it will
          qmk(icc,Q_K2)=qvk(scndk(icc),Q_K) ! work. 
          qtp(bestvv(icc))=qtp(bestvv(icc))+1
          qmk(icc,Q_TJ)=qtp(bestvv(icc))
          qmk(icc,Q_V1)=qvp(bestvv(icc))
          qmk(icc,Q_T )=icc
          if (((ctlint(C_EVAL).gt.0).and.(fistat.eq.0))
     $         .or.(ctlint(C_EVAL).gt.1)) then
            write(20,
     $       '(4i3,2X,4i3,F15.8,1X,I6,F14.3,I4,F6.3,I4,F6.3,I4,F6.3)')
     $         j,gam,ib,f,qmk(icc,Q_T),qmk(icc,Q_TJ),qmk(icc,Q_K)
     $         ,qmk(icc,Q_V1),eval(icc)
     $         ,qvk(bestk(icc),Q_K),sqrt(ksum(bestk(icc),icc))
     $         ,bestvv(icc),sqrt(vvsum(bestvv(icc),icc))
     $         ,qvk(scndk(icc),Q_K),sqrt(ksum(scndk(icc),icc))
     $         ,scndvv(icc),sqrt(vvsum(scndvv(icc),icc))
C     $         ,(bestv(icc,itop),vsum(bestv(icc,itop),icc,itop)
C     $         ,itop=1,ctlint(C_NTOP))
          end if
        end if         
      end do
      if (gam.gt.0) then
        if (kdegen) gamma(gam,0)=1
      end if
      return

      end

C----------------------------------------------------------------------
       subroutine rotate(d,beta,j,oldj)
       implicit none
       include 'iam.fi'
       real*8  d(-DIMJ:DIMJ,-DIMJ:DIMJ,1:2)
       real*8  beta
       integer j,oldj,ij
       if ((j.eq.0).or.(j.eq.1)) then
         call rotat1(d,beta,j)
         oldj=j
       end if
       if (oldj.eq.j) return
       if (oldj.gt.j) then
         do ij=1, j 
           call rotat1(d,beta,ij)
         end do
       end if
       if (oldj.lt.j) then
         do ij=oldj+1, j 
           call rotat1(d,beta,ij)
         end do
       end if
       oldj=j
       return
       end

C ---------------------------------------------------------------------
       subroutine rotat1(d,beta,j)
       implicit none
       include 'iam.fi'
       real*8  d(-DIMJ:DIMJ,-DIMJ:DIMJ,1:2)
       real*8  da(-DIMJ-1:DIMJ+1,-DIMJ-1:DIMJ+1,1:2)
       real*8 d1(-2:2,-2:2, 1:2)
       real*8 cg(-1:1,-DIMJ-1:DIMJ+1)
       real*8 beta,djj1
       real*8 dnew,ddnew,cb,sb,dcb,dsb
       integer k,j,k1,k2,m1,m2

       if (j.eq.0) then
         d(0,0,1)=1.0d0
         d(0,0,2)=0.0d0
         return
       endif
C
C       D1(beta) Matrix initialisieren
C
       if(beta.ne.0.0d0) then
         cb=0.5d0 * dcos(beta)
         sb=0.5d0 * dsqrt(2.0d0) * dsin(beta)
         d1(-1,-1,1)=0.5d0 + cb
         d1(-1, 1,1)=0.5d0 - cb
         d1(-1, 0,1)=sb
         d1( 0, 0,1)=2.d0 * cb
         d1( 1, 1,1)= d1(-1,-1,1)
         d1( 0,-1,1)=-d1(-1, 0,1)
         d1( 1,-1,1)= d1(-1, 1,1)
         d1( 0, 1,1)= d1(-1, 0,1)
         d1( 1, 0,1)= d1( 0,-1,1)         
       else
         d1(-1,-1,1)=1.0d0
         d1( 0, 0,1)=1.0d0
         d1( 1, 1,1)=1.0d0
         d1(-1, 1,1)=0.0d0
         d1( 1,-1,1)=0.0d0
         d1( 0,-1,1)=0.0d0
         d1(-1, 0,1)=0.0d0
         d1( 0, 1,1)=0.0d0
         d1( 1, 0,1)=0.0d0
       end if
       dcb=-0.5d0 * dsin(beta)
       dsb=0.5d0 * dsqrt(2.0d0) * dcos(beta)
       d1(-1,-1,2)=dcb
       d1(-1, 1,2)=-dcb
       d1(-1, 0,2)=dsb
       d1( 0, 0,2)=2.d0 * dcb
       d1( 1, 1,2)= d1(-1,-1,2)
       d1( 0,-1,2)=-d1(-1, 0,2)
       d1( 1,-1,2)= d1(-1, 1,2)
       d1( 0, 1,2)= d1(-1, 0,2)
       d1( 1, 0,2)= d1( 0,-1,2)
C
       if ((j.eq.1)) then
         do k1=-1,1
           do k2=-1,1
             d(k1,k2,1)=d1(k1,k2,1)
             d(k1,k2,2)=d1(k1,k2,2)
           end do
         end do
       end if
       if (j.eq.1) return

       do k1=-j,j
         do k2=-j,j
           da(k1,k2,1)=d(k1,k2,1)
           da(k1,k2,2)=d(k1,k2,2)
         end do
       end do
       do k1=1,2
         do k2=-j-1,j+1
           da( j+1,k2,k1)=0.0d0
           da(-j-1,k2,k1)=0.0d0
           da(k2, j+1,k1)=0.0d0
           da(k2,-j-1,k1)=0.0d0
         end do
       end do

C
C   Clebsch Gordan Koeffizienten
C
       do k=-j,j
         djj1=dble(J*(2*J-1))
C       <J-1  M   1  0|JM>
         cg(0,k)=dsqrt(dble((j-k) * (j+k))/djj1)
C       <J-1  M+1 1 -1|JM>
         cg(-1,k)=dsqrt(dble((j-k-1)*(j-k))/(2.0d0*djj1))
C       <J-1  M-1 1 +1|JM>
         cg( 1,k)=dsqrt(dble((j+k-1)*(j+k))/(2.0d0*djj1))
C         write(*,1003) j,k,cg(-1,k), cg(0,k), cg(1,k), djj1
 1003  format(' J  K ',2I4,'   m+1  m  m-1',4F10.4)
       end do
C
C       do k1=0,j
C         do k2=k1,j
       do k1=-j,j
         do k2=-j,j
           dnew=0.0d0
           ddnew=0.0d0
           do m1=-1,1
             do m2=-1,1
             dnew=dnew
     $            + cg(m1,k1)*d1(m1,m2,1)*da(k1-m1,k2-m2,1)*cg(m2,k2)
             ddnew=ddnew
     $            + cg(m1,k1)*d1(m1,m2,1)*da(k1-m1,k2-m2,2)*cg(m2,k2)
     $            + cg(m1,k1)*d1(m1,m2,2)*da(k1-m1,k2-m2,1)*cg(m2,k2)
             end do
           end do
           d(k1,k2,1)=dnew
C          da(-k2,-k1)=dnew
           d(k1,k2,2)=ddnew
C          dda(-k2,-k1)=ddnew
C          if (myand((k2-k1),1).eq.1) then
C            da(k2,k1)= dnew
C            dda(k2,k1)= ddnew
C          else
C            da(k2,k1)=-dnew
C            dda(k2,k1)=-ddnew
C          endif
C          da(-k1,-k2) = da(k2,k1)
C          dda(-k1,-k2) = dda(k2,k1)
         end do
       end do
C
       return
       end
